/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	Offline教材 オフラインログのItemsタグデータ保持クラス
//			変更履歴
//				2004.01.08	新規作成	二條　智文
//
package jp.co.ntt.lms.lo.Offline.OfflineLog;

import org.w3c.dom.*;
import java.util.*;

/**
 * Offline教材 オフラインログのItemsタグデータ保持クラス<BR>
 * オフラインログの<items>ノードを受け取り、自身の内部変数にデータを
 * 格納します。
 */
public class OfflineItems implements OfflineLogConst {

	// 自身のノードオブジェクトを保持します。
	private Element mobjItemsElm = null;

	// エラーメッセージ
	private static final String ERR_PRE = "<items>:";
	private static final String ERR_NOT_ITEMS = ERR_PRE + "itemsタグではありません。";
	private static final String ERR_NOEXIST_ITEM = ERR_PRE + "itemタグが存在しません。";

	// Itemエレメントデータを保持します。
	private Vector mvecItems = new Vector();

	/**
	 * コンストラクタです。
	 * @param objNode Itemsエレメントオブジェクト
	 * @exception OfflineLogParseException パースエラー
	 */
	OfflineItems( Element objElement )
		throws OfflineLogParseException
	{
		// タグ名のチェック(item以外はエラーとする)
		String strTagName = objElement.getTagName();
		if( strTagName == null || !strTagName.equals( ITEMS_ELM ) ) {
			throw new OfflineLogParseException( ERR_NOT_ITEMS );
		}

		mobjItemsElm = objElement;

		parse();
	}

	/**
	 * 保持しているitemエレメントデータの長さを取得します。
	 * @return int
	 */
	public int getItemLength() {
		return mvecItems.size();
	}

	/**
	 * 指定されたインデックスのitemエレメントデータを取得します。
	 * @return OfflineItem
	 */
	public OfflineItem getItem( int index ) {
		return (OfflineItem)mvecItems.get(index);
	}

	/**
	 * エレメントIDを指定して、該当する<item>エレメントデータ
	 * を取得します。
	 * @param strID エレメントID
	 * @return OfflineItem 該当する<item>エレメントデータ
	 *                     存在しない場合はnullを返す。
	 */
	public OfflineItem getItemFromID( String strID ) {

		if( strID == null ) {
			return null;
		}

		OfflineItem objItem = null;
		// 該当するIDを持つItemエレメントデータを探す
		for( int i = 0; i < mvecItems.size(); i++ ) {
			objItem = (OfflineItem)mvecItems.get(i);

			if( objItem.getID() != null &&
				objItem.getID().equals( strID ) )
			{
				return objItem;
			}
		}
		return null;
	}

	/**
	 * エレメントIDと学習回数と表示回数を指定して、該当する<item>-<ses>エレメントデータ
	 * を取得します。
	 * @param strID エレメントID
	 * @param intMCNT 学習回数
	 * @param intNCNT 表示回数
	 * @return OfflineItemSes 該当する<item>-<ses>エレメントデータ
	 *                        存在しない場合はnullを返す。
	 */
	public OfflineItemSes getSesFromIdMcntNcnt( String strID, int intMCNT, int intNCNT ) {

		// 該当するIDを持つItemエレメントデータを探す
		OfflineItem objItem = getItemFromID( strID );

		if( objItem == null ) {
			return null;
		}

		return objItem.getSesFromMcntNcnt( intMCNT, intNCNT );
	}

//----------------------------------- 内部関数 ---------------------------------
	/**
	 * コンストラクタで受け取ったエレメントないのデータを
	 * 取得して、自身の変数に格納します。
	 */
	private void parse()
		throws OfflineLogParseException
	{

		// 配下のItemエレメントを取得する
		NodeList objItemList = mobjItemsElm.getElementsByTagName( ITEM_ELM );

		if( objItemList.getLength() == 0 ) {
			throw new OfflineLogParseException( ERR_NOEXIST_ITEM );
		}

		Element objItemElm = null;
		for ( int i=0; i<objItemList.getLength(); i++ ){
			objItemElm = (Element)objItemList.item(i);

			// Itemエレメントリスト用のVectorに追加する。
			mvecItems.add(new OfflineItem( objItemElm ));

		}

	}
//----------------------------------- 内部関数 ---------------------------------

}

